/**
 * Parse an object key from dot notation
 * @example
 * parseKey('person.name', 'John Doe');
 * // output { person: { name: 'John Doe' } }
 * parseKey('person.alias[]', 'John Doe');
 * // output { person: { alias: ['John Doe'] } }
 * @param {string} path - Dot notation path
 * @param {unknown} value
 * @returns {object}
 */
declare const parseKey: <T>(path: string, value: unknown) => T extends [] ? T[] : T;
export default parseKey;
